com.google.cloud.dataflow.sdk.transforms

## Class ParDo.Unbound

- java.lang.Object
- - com.google.cloud.dataflow.sdk.transforms.ParDo.Unbound

Enclosing class:
  ParDo

    public static class ParDo.Unbound
    extends Object

An incomplete `ParDo` transform, with unbound input/output types.

Before being applied, `of(com.google.cloud.dataflow.sdk.transforms.DoFn<InputT, OutputT>)` must be invoked to specify the `DoFn` to invoke, which will also bind the input/output types of this `PTransform`.

### Method Summary

All Methods Instance Methods Concrete Methods
`ParDo.Unbound` `named(String name)` Returns a new `ParDo` transform that's like this transform but with the specified name.
`<InputT,OutputT> ParDo.Bound<InputT,OutputT>` `of(DoFn<InputT,OutputT> fn)` Returns a new `ParDo` `PTransform` that's like this transform but that will invoke the given `DoFn` function, and that has its input and output types bound.
`<InputT,OutputT> ParDo.Bound<InputT,OutputT>` `of(DoFnWithContext<InputT,OutputT> fn)` Returns a new `ParDo` `PTransform` that's like this transform but which will invoke the given `DoFnWithContext` function, and which has its input and output types bound.
`<OutputT> ParDo.UnboundMulti<OutputT>` `withOutputTags(TupleTag<OutputT> mainOutputTag, TupleTagList sideOutputTags)` Returns a new multi-output `ParDo` transform that's like this transform but with the specified main and side output tags.
`ParDo.Unbound` `withSideInputs(Iterable<? extends PCollectionView<?>> sideInputs)` Returns a new `ParDo` transform that is like this transform but with the specified additional side inputs.
`ParDo.Unbound` `withSideInputs(PCollectionView<?>... sideInputs)` Returns a new `ParDo` transform that's like this transform but with the specified additional side inputs.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### named

    public ParDo.Unbound named(String name)

Returns a new `ParDo` transform that's like this transform but with the specified name. Does not modify this transform. The resulting transform is still incomplete.

See the discussion of naming above for more explanation.

#### withSideInputs

    public ParDo.Unbound withSideInputs(PCollectionView<?>... sideInputs)

Returns a new `ParDo` transform that's like this transform but with the specified additional side inputs. Does not modify this transform. The resulting transform is still incomplete.

See the discussion of Side Inputs above and on `ParDo.withSideInputs(com.google.cloud.dataflow.sdk.values.PCollectionView<?>...)` for more explanation.

#### withSideInputs

    public ParDo.Unbound withSideInputs(Iterable<? extends PCollectionView<?>> sideInputs)

Returns a new `ParDo` transform that is like this transform but with the specified additional side inputs. Does not modify this transform. The resulting transform is still incomplete.

See the discussion of Side Inputs above and on `ParDo.withSideInputs(com.google.cloud.dataflow.sdk.values.PCollectionView<?>...)` for more explanation.

#### withOutputTags

    public <OutputT> ParDo.UnboundMulti<OutputT> withOutputTags(TupleTag<OutputT> mainOutputTag,
                                                                TupleTagList sideOutputTags)

Returns a new multi-output `ParDo` transform that's like this transform but with the specified main and side output tags. Does not modify this transform. The resulting transform is still incomplete.

See the discussion of Side Outputs above and on `ParDo.withOutputTags(com.google.cloud.dataflow.sdk.values.TupleTag<OutputT>, com.google.cloud.dataflow.sdk.values.TupleTagList)` for more explanation.

#### of

    public <InputT,OutputT> ParDo.Bound<InputT,OutputT> of(DoFn<InputT,OutputT> fn)

Returns a new `ParDo` `PTransform` that's like this transform but that will invoke the given `DoFn` function, and that has its input and output types bound. Does not modify this transform. The resulting `PTransform` is sufficiently specified to be applied, but more properties can still be specified.

#### of

    public <InputT,OutputT> ParDo.Bound<InputT,OutputT> of(DoFnWithContext<InputT,OutputT> fn)

Returns a new `ParDo` `PTransform` that's like this transform but which will invoke the given `DoFnWithContext` function, and which has its input and output types bound. Does not modify this transform. The resulting `PTransform` is sufficiently specified to be applied, but more properties can still be specified.